#
#ifndef	DAB_CONCURRENT
#define	DAB_CONCURRENT

#include	"dab_virtual.h"
#include	<QThread>
#include	<QMutex>
#include	<QWaitCondition>
#include	"ringbuffer.h"

class	dabProcessor;
class	uep_deconvolve;
class	eep_deconvolve;
class	audioSink;
class	RadioInterface;

class	dabConcurrent:public QThread, public dabVirtual {
public:
	dabConcurrent	(uint8_t dabModus,
	                 int16_t fragmentSize,
	                 int16_t bitRate,
	                 int16_t uepFlag,
	                 int16_t protLevel,
	                 int16_t tracebackLevel,
	                 RadioInterface *mr,
	                 audioSink *as);
	~dabConcurrent	(void);
int32_t	process		(int16_t *, int16_t);
void	stopRunning	(void);
private:
void	run		(void);
	volatile bool	running;
	uint8_t	dabModus;
	int16_t	fragmentSize;
	int16_t	bitRate;
	int16_t	uepFlag;
	int16_t	protLevel;
	int16_t	tracebackLevel;
	RadioInterface	*myRadioInterface;
	audioSink	*myAudioSink;

	uint8_t		*outV;
	int16_t		**interleaveData;
	int16_t		*Data;

	QWaitCondition	Locker;
	QMutex		ourMutex;

	uep_deconvolve	*uepProcessor;
	eep_deconvolve	*eepProcessor;
	dabProcessor	*our_dabProcessor;
	RingBuffer<int16_t>	*Buffer;
};

#endif

