#
#ifndef	DAB_SERIAL
#define	DAB_SERIAL

#include	"dab_virtual.h"

class	dabProcessor;
class	uep_deconvolve;
class	eep_deconvolve;
class	audioSink;
class	RadioInterface;

class	dabSerial: public dabVirtual {
public:
	dabSerial	(uint8_t dabModus,
	                 int16_t fragmentSize,
	                 int16_t bitRate,
	                 int16_t uepFlag,
	                 int16_t protLevel,
	                 int16_t tracebackLevel,
	                 RadioInterface *mr,
	                 audioSink *as);
	~dabSerial	(void);
int32_t	process		(int16_t *, int16_t);
void	stopRunning	(void);
private:
	uint8_t	dabModus;
	int16_t	fragmentSize;
	int16_t	bitRate;
	int16_t	uepFlag;
	int16_t	protLevel;
	int16_t	tracebackLevel;
	RadioInterface	*myRadioInterface;
	audioSink	*myAudioSink;
	int32_t	countforInterleaver;
	uint8_t		*outV;
	int16_t		**interleaveData;
	int16_t		*Data;

	uep_deconvolve	*uepProcessor;
	eep_deconvolve	*eepProcessor;
	dabProcessor	*our_dabProcessor;
};

#endif

