
#
//
//	This file will be included in mp4processor
//
#
#include	"neaacdec.h"
#include	"audiosink.h"

class	faadDecoder {
private:
	bool			processorOK;
	bool			aacInitialized;
	uint32_t		aacCap;
	NeAACDecHandle		aacHandle;
	NeAACDecConfigurationPtr	aacConf;
	NeAACDecFrameInfo	hInfo;
	audioSink		*ourSink;
	int32_t			baudRate;
//
public:
	faadDecoder	(audioSink *as) {
	ourSink		= as;
	
	aacCap		= NeAACDecGetCapabilities	();
	aacHandle	= NeAACDecOpen			();
	aacConf		= NeAACDecGetCurrentConfiguration (aacHandle);
	aacInitialized	= false;
	baudRate	= 48000;
}

	~faadDecoder	(void) {
	NeAACDecClose	(aacHandle);
}

void	setPCMrate	(int32_t rate) {
	if (baudRate == rate)
	   return;
	if (rate == 0)	// sure, it is an error
	   return;
	baudRate	= rate;
	fprintf (stderr, "setting rate to %d\n", rate);
	ourSink		-> setMode (0, rate);
}

int16_t	MP42PCM (uint8_t buffer [], int16_t bufferLength) {
int16_t	len;
int16_t	i;
int16_t	samples;
uint8_t	channels;
long unsigned int	sample_rate;
int16_t	*outBuffer;
NeAACDecFrameInfo	hInfo;

	if (!aacInitialized) {
	   len = NeAACDecInit (aacHandle, 
	                       buffer, bufferLength, &sample_rate, &channels);
	   if (len < 0) {
	      fprintf (stderr, "Cannot handle this frame\n");
	      return 0;
	   }

	   outBuffer = (int16_t *)NeAACDecDecode (aacHandle,
	                               &hInfo,
	                               &buffer [len],
	                               (uint64_t)(bufferLength - len));
	   aacInitialized = true;
	}
	else 
	   outBuffer = (int16_t *)NeAACDecDecode (aacHandle,
	                                          &hInfo,
	                                          buffer,
	                                          (uint64_t)bufferLength);

	sample_rate	= hInfo. samplerate;
	samples		= hInfo. samples;
	if (sample_rate != baudRate)
	      setPCMrate (sample_rate);
	
//	fprintf (stderr, "bytes consumed %d\n", (int)(hInfo. bytesconsumed));
//	fprintf (stderr, "samplerate = %d, samples = %d, channels = %d, error = %d, sbr = %d\n", sample_rate, samples,
//	         hInfo. channels,
//	         hInfo. error,
//	         hInfo. sbr);
//	fprintf (stderr, "header = %d\n", hInfo. header_type);
	channels	= hInfo. channels;
	if (hInfo. error != 0) {
	   fprintf (stderr, "Warning: %s\n",
	               faacDecGetErrorMessage (hInfo. error));
	   return 0;
	}
	   
	if (channels == 2)
	   ourSink	-> audioOut ((int16_t *)outBuffer, samples / 2);
	else
	if (channels == 1) {
	   int16_t *buffer = (int16_t *)alloca (2 * samples);
	   int16_t i;
	   for (i = 0; i < samples; i ++) {
	      buffer [2 * i]	= ((int16_t *)outBuffer) [i];
	      buffer [2 * i + 1] = buffer [2 * i];
	   }
	   ourSink -> audioOut (outBuffer, samples);
	}
	else
	   fprintf (stderr, "Cannot handle these channels\n");

	return samples / 2;
}

};
