#
#ifndef	UINT64_C
#define	UINT64_C	uint64_t
#endif

extern "C" {
#include	<libavutil/opt.h>
#include 	<libavcodec/avcodec.h>
#include 	<libavutil/common.h>
#include 	<libavutil/imgutils.h>
#include 	<libavutil/mathematics.h>
#include 	<libavutil/samplefmt.h>
}

#
//	specifics for the ffmpeg converter
class	ffmpegDecoder {
private:
	AVFrame		*decoded_frame;
	AVCodecContext	*context;
	AVCodec		*codec;
	AVPacket	avpkt;
	bool		decoderOK;
	audioSink	*ourSink;
	int32_t		baudRate;

public:
	ffmpegDecoder	(audioSink *as) {
	decoderOK		= false;
	ourSink			= as;
	avcodec_register_all		();
	av_init_packet			(&avpkt);
	codec			= avcodec_find_decoder (CODEC_ID_AAC);
	if (codec == NULL) {
	   fprintf (stderr, "Codec not found\n");	
	   return;
	}

	context			= avcodec_alloc_context3 (codec);
	if (context == NULL) {
	   fprintf (stderr, "Could not allocate codec context\n");
	   return;
	}

	if (avcodec_open2 (context, codec, NULL) < 0) {
	   fprintf (stderr, "Could not open codec\n");
	   return;
	}

	decoded_frame	= avcodec_alloc_frame ();
	if (decoded_frame == NULL) {
	   fprintf (stderr, "Could not allocate audioframe\n");
	   return;
	}
	baudRate		= 48000;
	decoderOK		= true;
}

		~ffmpegDecoder	(void) {
	av_free	(context);
}


void	setPCMrate	(int32_t rate) {
	if (baudRate == rate)
	   return;
	baudRate	= rate;
	fprintf (stderr, "setting rate to %d\n", rate);
	ourSink		-> setMode (0, rate);
}

int32_t	MP42PCM (uint8_t buffer [], int16_t length) {
int32_t	got_frame;
long unsigned int	sample_rate;
int16_t	len;
int16_t	i;
int32_t	amount;
int16_t	channels;
//
//	fwrite (buffer, 1, length, stdout);
	avcodec_get_frame_defaults (decoded_frame);

	avpkt. data	= buffer;
	avpkt. size	= length;
	len		= avcodec_decode_audio4 (context,
	                                         decoded_frame,
	                                         &got_frame,
	                                         &avpkt);

	if (len < 0) {	// an error 
	   return 0;
	}

	if (got_frame) {
	   int32_t bs =  av_samples_get_buffer_size (NULL,
	                                       context -> channels,
	                                       decoded_frame -> nb_samples,
	                                       context -> sample_fmt, 1);
	   sample_rate	= context -> sample_rate;
	   amount	= decoded_frame -> nb_samples;
	   channels	= context -> channels;

	   if (sample_rate != baudRate)
	      setPCMrate (sample_rate);
	   if (channels == 2)
	      ourSink	-> audioOut ((int16_t *)(decoded_frame -> data [0]),
	                             amount);
	   else
	   if (channels == 1) {
	      int16_t *buffer = (int16_t *)alloca (2 * bs);
	      int16_t i;
	      for (i = 0; i < amount; i ++) {
	         buffer [2 * i]	= ((int16_t *)(decoded_frame -> data [0])) [i];
	         buffer [2 * i + 1] = buffer [2 * i];
	      }
	      ourSink -> audioOut (buffer, amount);
	   }

	   return amount;
	}

	return 0;
}
};

