#
/*
 * 	FIC data
 */
#ifndef	__FIC_HANDLER
#define	__FIC_HANDLER

#include	<stdio.h>
#include	<stdint.h>
#include	"viterbi.h"
#include	<QObject>


class	RadioInterface;
class	mscHandler;
class	fib_processor;

class ficHandler: public QObject, public viterbi {
Q_OBJECT
public:
		ficHandler		(RadioInterface *,
	                                 int16_t,
	                                 mscHandler *);
		~ficHandler		(void);
	void	process_ficBlock	(int16_t *, int16_t);
	void	setSelectedService	(char *);
	void	unnamedService		(int);
	void	clearEnsemble		(void);
	int16_t	get_ficRatio		(void);
private:
	void	process_ficInput	(int16_t *, int16_t);
	bool	check_ficCRC		(uint8_t *, int16_t);
	int16_t	tracebackLevel;
	int8_t	*PI_15;
	int8_t	*PI_16;
	int8_t	*PI_X;
	uint8_t	*bitBuffer_in;
	uint8_t	*bitBuffer_out;
	int16_t	*ofdm_input;
	int16_t	index;
	int16_t		ficno;
	int16_t		ficBlocks;
	int16_t		ficMissed;
	int16_t		ficRatio;
	uint16_t	convState;
	fib_processor	*fibProcessor;
	uint8_t		PRBS [768];
	uint8_t		shiftRegister [9];
signals:
	void		show_ficRatio	(int);
};

#endif


