#
#ifndef MP2PROCESSOR
#define	MP2PROCESSOR

#include	<stdio.h>
#include	<stdint.h>
#include	<math.h>
#include	"dab_processor.h"
#include	"audiosink.h"
#include	"dab-constants.h"
#include	<QObject>

#ifndef	UINT64_C
#define	UINT64_C	uint64_t
#endif

extern "C" {
#include	<libavutil/opt.h>
#include 	<libavcodec/avcodec.h>
#include 	<libavutil/common.h>
#include 	<libavutil/imgutils.h>
#include 	<libavutil/mathematics.h>
#include 	<libavutil/samplefmt.h>
}

class	RadioInterface;

class	mp2Processor : public QObject, public dabProcessor {
Q_OBJECT
public:
		mp2Processor	(RadioInterface *, audioSink *, int16_t);
		~mp2Processor	(void);
	void	addtoFrame	(uint8_t *, int16_t);

private:

	void		processFrame		(uint8_t *, int16_t);
	void		setPCMrate		(int32_t);
	RadioInterface	*myRadioInterface;
	uint8_t		*MP2frame;
	int32_t		baudRate;
	int16_t		MP2framesize;
	int8_t		MP2fillState;
	int16_t		MP2headerCount;
	int16_t		MP2bitCount;
	void		addbittoMP2	(uint8_t *, uint8_t, int16_t);

	bool		processorOK;
	AVFrame		*decoded_frame;
	AVCodecContext	*context;
	AVCodec		*codec;
	audioSink	*ourSink;
	AVPacket	avpkt;
	int32_t		numberofErrors;
	int32_t		numberofFrames;

signals:
	void		show_successRate	(int);
};
#endif

