#
/*
 *    viterbi.h  --  Viterbi decoder
 *
 */
#ifndef _VITERBI_DECODER_H
#define _VITERBI_DECODER_H
#include	<stdio.h>
#include	<string.h>
#include	<limits.h>
#include	<stdint.h>

//
//	experimental setting for 1/4 7 decoder
class viterbi {
public:
		viterbi			(int16_t);
		~viterbi 		(void);
//
	int16_t	viterbi_shiftbit	(int16_t, int32_t *);
	int16_t	viterbi_decode		(int16_t *, int32_t *);
	void	viterbi_reset		(int16_t, int16_t);
	int16_t	viterbi_set_chunksize	(int16_t);
	int16_t	v_traceLength;
	uint8_t bitFor			(uint16_t, uint16_t, uint8_t);
private:
	int16_t	traceBack		(uint16_t, int16_t, int32_t *);
	int16_t	costsFor		(uint16_t, uint8_t, int16_t *);
	int16_t	LengthofShiftregister;
	int16_t	NumofStates;
	uint16_t	stateMask;
	int16_t	Poly1;
	int16_t	Poly2;
	int16_t	Poly3;
	int16_t	Poly4;
	int16_t	v_chunksize;
	int32_t	**transCosts;
	int16_t	**history;
	int16_t	*sequence;
	uint16_t globalPtr;
	uint8_t	*poly1_table;
	uint8_t	*poly2_table;
	uint8_t	*poly3_table;
	uint8_t	*poly4_table;
	uint8_t	*table5;
	int32_t	count;
	int16_t	bitBufferIndex;
	int16_t	bitBuffer [4];
};
#endif
