#
#include	<stdint.h>
#include	<stdio.h>
#include	"mapper.h"
/*
 *
 * 	Simple mapper/demapper for dab mode-I
 */

	permVector::permVector () {
int16_t	i;
int16_t	index	= 0;
int16_t	tmp	[2048];

	permTable	= new int16_t [1536];
	index = 0;
//
//	step 1: generate the permutation
	tmp [0] = 0;
	for (i = 1; i < 2048; i ++) 
	   tmp [i] = (13 * tmp [i - 1] + 511) % 2048;
//
//	step 2: make it into a 1536 element map

	for (i = 0; i < 2048; i ++) {
	   if (tmp [i] == 1024)
	      continue;
	   if ((tmp [i] < 256) ||
	       (tmp [i] > 1792)) 
	      continue;
//	we now have a table with values from 256 .. 1792
//
	   permTable [index ++] = tmp [i] - 1024;
//	we now have a table with values from -768 .. 768
	}
}
//
//
	permVector::~permVector (void) {
	delete	permTable;
}
//
//	according to the standard, the map is a function from
//	0 .. 1535 -> -768 .. 768 (with exclusion of {0})
int16_t	permVector::mapIn (int16_t n) {
	return permTable [n];
}



