#
/*
 *
 *
 */
#ifndef	TOKEN_DECODER
#define	TOKEN_DECODER

#include	<stdint.h>
#include	"dab-constants.h"
#include	"fft.h"
#include	"mapper.h"
#include	"phasetable.h"
#include	<QObject>
#include	"ringbuffer.h"

class	RadioInterface;
class	SinCos;

class	ofdm_decoder: public QObject{
Q_OBJECT
public:
		ofdm_decoder		(int32_t, int32_t,
	                                 RingBuffer<DSPCOMPLEX> *,
	                                 bool,
	                                 RadioInterface *);
		~ofdm_decoder		(void);
	void	initTables		(void);
	void	processBlock_0		(DSPCOMPLEX *);
	void	processToken		(DSPCOMPLEX *, int16_t *, int32_t n);
	int16_t	get_snr			(DSPCOMPLEX *);
	int16_t	coarseCorrector		(void);
	void		set_displayToken	(int16_t);
private:
	int32_t		T_s;
	int32_t		T_u;
	RingBuffer<DSPCOMPLEX> *iqBuffer;
	bool		lightRun;
	int16_t		getMiddle	(DSPCOMPLEX *);
	RadioInterface	*myRadioInterface;
	int32_t	delta;
	DSPCOMPLEX	*phaseReference;
	common_fft	*fft_handler;
	DSPCOMPLEX	*fft_buffer;
	permVector	*myMapper;
	phaseTable	*phasetable;
	int32_t		blockIndex;
	int16_t		iqCount;
	int16_t		coarseOffset;
	int16_t		displayToken;
	int16_t		snrCount;
	int16_t		snr;
signals:
	void		show_snr	(int);
	void		showIQ		(int);
};

#endif


