#
/*
 */
#include	"phasereference.h" 

	phaseReference::phaseReference (DSPCOMPLEX *buffer,
	                                uint32_t syncBuffermask, int32_t Tu) {
int32_t	i;
DSPFLOAT	Phi_k;

	this	-> buffer	= buffer;
	this	-> bufferMask	= syncBuffermask;
	this	-> Tu		= Tu;

	Max			= 0.0;
	refTable		= new DSPCOMPLEX 	[Tu];	//

	fft_processor		= new common_fft 	(Tu);
	fft_buffer		= fft_processor		-> getVector ();
	res_processor		= new common_ifft 	(Tu);
	res_buffer		= res_processor		-> getVector ();
	fft_counter		= 0;

	for (i = 0; i < Tu; i ++)
	   refTable [i] = 0;

	for (i = 1; i <= 768; i ++) {
	   Phi_k =  get_Phi (i);
	   refTable [i - 1] = DSPCOMPLEX (cos (Phi_k), sin (Phi_k));
	   Phi_k = get_Phi (-i);
	   refTable [Tu - i] = DSPCOMPLEX (cos (Phi_k), sin (Phi_k));
	}
}

	phaseReference::~phaseReference (void) {
	delete	refTable;
	delete	fft_processor;
}

int32_t	phaseReference::findIndex (uint32_t index, uint32_t amount) {
int32_t	i;
int32_t	maxIndex 	= -1;

	Max	= 1.0;
	for (i = 0; i < (int32_t)amount; i ++)
	   fft_buffer [i] = buffer [(index + i) & bufferMask];

	for (i = amount; i < Tu; i ++)
	   fft_buffer [i] = 0;
	fft_processor -> do_FFT ();
//
//	back into the frequency domain, now correlate
	for (i = 0; i < Tu; i ++) 
	   res_buffer [i] = fft_buffer [i] * conj (refTable [i]);
//	and, again, back into the time domain
	res_processor	-> do_IFFT ();
//
	for (i = 0; i < (int32_t)amount; i ++)
	   if (abs (res_buffer [i]) > Max) {
	      maxIndex = i;
	      Max = abs (res_buffer [i]);
	   }

	return maxIndex;	// if not found, it will be -1
}

