#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JSDR.
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	FMPILOTPLL
#define	FMPILOTPLL

#include	"fm-constants.h"
#include	"sincos.h"
#include	"iir-filters.h"

//	for the 19 kHz pilot to synchronize, we
//	have a special pll
//
class FMPilotPLL {
private:
	DSPFLOAT		pll_corrector;
	DSPFLOAT		loopGain;
	int32_t			rate;
	int32_t			pll_cf;
	DSPFLOAT		omega;
	DSPFLOAT		oldRef;
	bool			locked;
	DSPFLOAT		NcoPhase;
	SinCos			*mySinCos;
	LowPassIIR		*loop_lowPass;
	LowPassIIR		*lock_lowPass;
	DSPFLOAT		old_error;
	DSPFLOAT		averagePhaseError;
public:
	FMPilotPLL		(DSPFLOAT ki,
	                         int32_t rate, int32_t cf, 
	                         SinCos	*);
	~FMPilotPLL		(void);
void	upDate			(DSPFLOAT);
DSPFLOAT	process		(DSPFLOAT refvalue);
DSPFLOAT	getDelta	(void);
bool		isLocked	(void);
};
#endif

