
#
/*
 *  In order to test the functionality of the DAB receiver,
 *  we build a straight formward test system that will
 *  generate samples on demand
 *  Depending on the settings, we can add noise as well
 *
 *  The main interface is compatible with our receiver side,
 *  so we provide a re-implementation of the "getSamples"
 *  function in a generator class.
 */
#ifndef	__FILE_READER
#define	__FILE_READER

#include	<stdint.h>
#include	<stdio.h>
#include	"jff-include.h"
#include	"virtual_input.h"
#include	"ringbuffer.h"
#include	<QThread>

#define	NULL_SYMBOL	0100
#define	PRS_SYMBOL	0101
#define	DAB_SYMBOL	0102

#define	NullDuration	2656
#define	Ts		2552
#define	Tu		2048

class	fileReader : public virtualInput, QThread {
public:
			fileReader	(const char *, bool *);
	       		~fileReader	(void);
	int32_t		getSamples	(uint8_t *, int32_t);
	uint8_t		myIdentity	(void);
	int32_t		Samples		(void);
	bool		restartReader	(void);
	void		stopReader	(void);
private:
virtual	void		run		(void);
	int32_t		readBuffer	(uint8_t *, int32_t);
	RingBuffer<uint8_t>	*_I_Buffer;
	int32_t		bufferSize;
const	char		*fileName;
	FILE		*filePointer;
	bool		readerOK;
	bool		readerPausing;
	bool		ExitCondition;
	bool		ThreadFinished;
	int64_t		currPos;
};

#endif

