#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include	"iqdisplay.h"
#include	"spectrogramdata.h"
/*
 *	iq circle plotter
 */
SpectrogramData	*IQData	= NULL;

	IQDisplay::IQDisplay (QwtPlot *plot, int16_t x): QwtPlotSpectrogram () {
QwtLinearColorMap colorMap (Qt::black, Qt::white);
//QwtScaleWidget *rightAxis;
int32_t	i, j;

	plotgrid	= plot;
	x_amount	= x;
	Radius		= 100;
	CycleCount	= 0;
	Points		= new DSPCOMPLEX [x_amount];
	memset (Points, 0, x_amount * sizeof (DSPCOMPLEX));
	this		-> setColorMap (colorMap);
	plotData	= new double [2 * Radius * 2 * Radius];
	for (i = 1; i < 2 * Radius; i ++)
 	   for (j = 0; j < 2 * Radius; j ++)
	      plotData [(i - 1) * 2 * Radius + j] = 0;

	IQData		= new SpectrogramData (plotData,
	                                       0,
	                                       2 * Radius,
	                                       2 * Radius,
	                                       2 * Radius,
	                                       50.0);
	this		-> setData (*IQData);
	plot		-> enableAxis (QwtPlot::xBottom, 0);
	plot		-> enableAxis (QwtPlot::yLeft, 0);
	this		-> setDisplayMode (QwtPlotSpectrogram::ImageMode, TRUE);
	plotgrid	-> replot();
}

	IQDisplay::~IQDisplay () {
	this		-> detach ();
	delete[]	plotData;
	delete		IQData;
}

void	IQDisplay::DisplayIQ (DSPCOMPLEX z, float scale) {
int32_t	i;
int	x, y;
//	add new point
        x = (int)(scale * real (z));
        y = (int)(scale * imag (z));

	if (x >= Radius)
	   x = Radius - 1;
	if (y >= Radius)
	   y = Radius - 1;

	if (x <= - Radius)
	   x = -(Radius - 1);
	if (y <= - Radius)
	   y = -(Radius - 1);
//	register point
	Points [CycleCount] = DSPCOMPLEX (x, y);
	plotData [(x + Radius - 1) * 2 * Radius + y + Radius] = 50;

	if (++CycleCount < x_amount)
	   return;

	if (IQData != NULL)
	   delete IQData;
	IQData = new SpectrogramData (plotData,
                                      0,
	                              2 * Radius,
	                              2 * Radius,
	                              2 * Radius,
	                              50.0);
	this		-> detach	();
	this		-> setData	(*IQData);
	this		-> setDisplayMode (QwtPlotSpectrogram::ImageMode, TRUE);
	this		-> attach     (plotgrid);
	plotgrid	-> replot();

	for (i = 0; i < CycleCount; i ++) {
	   x = (int)(real (Points [i]));
	   y = (int)(imag (Points [i]));
	   plotData [(x + Radius - 1) * 2 * Radius + y + Radius] = 0;
	}
	CycleCount = 0;
}

